---
title: WEBGL_depth_texture
slug: Web/API/WEBGL_depth_texture
tags:
  - API
  - Reference
  - WebGL
  - WebGL extension
---
<div>{{APIRef("WebGL")}}</div>

<p>The <code><strong>WEBGL_depth_texture</strong></code> extension is part of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> and defines 2D depth and depth-stencil textures.</p>

<p>WebGL extensions are available using the {{domxref("WebGLRenderingContext.getExtension()")}} method. For more information, see also <a href="/en-US/docs/Web/API/WebGL_API/Using_Extensions">Using Extensions</a> in the <a href="/en-US/docs/Web/API/WebGL_API/Tutorial">WebGL tutorial</a>.</p>

<div class="note">
<p><strong>Availability:</strong> This extension is only available to {{domxref("WebGLRenderingContext", "WebGL1", "", 1)}} contexts. In {{domxref("WebGL2RenderingContext", "WebGL2", "", 1)}}, the functionality of this extension is available on the WebGL2 context by default. The constant in WebGL2 is <code>gl.UNSIGNED_INT_24_8</code>.</p>
</div>

<h2 id="Constants">Constants</h2>

<p>This extension adds a new constant:</p>

<dl>
 <dt><code>ext.UNSIGNED_INT_24_8_WEBGL</code></dt>
 <dd>Unsigned integer type for 24-bit depth texture data.</dd>
</dl>

<h2 id="Extended_methods">Extended methods</h2>

<p>This extension extends {{domxref("WebGLRenderingContext.texImage2D()")}}:</p>

<ul>
 <li>The <code>format</code> and <code>internalformat</code> parameters now accept <code>gl.DEPTH_COMPONENT</code> and <code>gl.DEPTH_STENCIL</code>.</li>
 <li>The <code>type</code> parameter now accepts <code>gl.UNSIGNED_SHORT</code>, <code>gl.UNSIGNED_INT</code>, and <code>ext.UNSIGNED_INT_24_8_WEBGL</code>.</li>
 <li>The <code>pixels</code> parameter now accepts an <code>ArrayBufferView</code> of type <code>Uint16Array</code> and <code>Uint32Array</code>.</li>
</ul>

<p>This extension extends {{domxref("WebGLRenderingContext.framebufferTexture2D()")}}:</p>

<ul>
 <li>The <code>attachment</code> parameter now accepts <code>gl.DEPTH_STENCIL_ATTACHMENT</code>.</li>
</ul>

<div class="note">
<p>Incorrectly stated as the <code>target</code> parameter in the specification, see <a href="https://www.khronos.org/bugzilla/show_bug.cgi?id=674">https://www.khronos.org/bugzilla/show_bug.cgi?id=674</a>.</p>
</div>


<h2 id="Examples">Examples</h2>

<pre class="brush:js">var ext = gl.getExtension('WEBGL_depth_texture');

gl.texImage2D(gl.TEXTURE_2D, 0, gl.DEPTH_COMPONENT, 512, 512, 0, gl.DEPTH_COMPONENT, gl.UNSIGNED_SHORT, null);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WEBGL_depth_texture', "", "WEBGL_depth_texture")}}</td>
   <td>{{Spec2('WEBGL_depth_texture')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WEBGL_depth_texture")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.getExtension()")}}</li>
 <li>{{domxref("WebGLRenderingContext.texImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.framebufferTexture2D()")}}</li>
</ul>
